## cppad 2025.00.00.0

=== CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-25 Bradley M. Bell
# ----------------------------------------------------------------------------
# =============================================================================
# Some constants
# =============================================================================
#
# Set the minimum required version of cmake for this project.
# see https://cmake.org//pipermail/cmake/2013-January/053213.html
CMAKE_MINIMUM_REQUIRED(VERSION 3.5)
#
# Only interpret if() arguments as variables or keywords when unquoted.
IF( POLICY CMP0054 )
  CMAKE_POLICY(SET CMP0054 NEW)
ENDIF( POLICY CMP0054 )
#
# cppad_version is used by version.sh to get the version number.
SET(cppad_version "20250000.0")
SET(cppad_url          "https://coin-or.github.io/CppAD" )
SET(cppad_description  "Differentiation of C++ Algorithms" )
IF( NOT DEFINED CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE "NOTFOUND")
ENDIF( NOT DEFINED CMAKE_BUILD_TYPE)
#
# Set name of this project and create the variables
# cppad_BINARY_DIR and cppad_SOURCE_DIR.
# project(projectname [CXX] [C] [Java])
PROJECT(cppad)
#
# Add the include sub-directory to the list of C++ preprocessor
# include directories for the entire project.  The SYSTEM flag is not included
# so warnings will be geenreated for this directory.
INCLUDE_DIRECTORIES( ${cppad_SOURCE_DIR}/include )
#
# =============================================================================
# Some system cmake language extensions
# =============================================================================
# CHECK_CXX_SOURCE_COMPILES(source variable)
# Checks whether the code given in source will compile, link and run and
# return zero status. You can set
# CMAKE_REQUIRED_LIBRARIES, CMAKE_REQUIRED_FLAGS and CMAKE_REQUIRED_INCLUDES
# accordingly if additional libraries or compiler flags are required.
INCLUDE(CheckCXXSourceCompiles)
# ============================================================================
# Some local cmake language
# ============================================================================
# assert_value_in_set(value element_1 ... element_n)
INCLUDE(cmake/assert_value_in_set.cmake)
#
# dos_path_to_unix(dos_path unix_path)
INCLUDE(cmake/dos_path_to_unix.cmake)
#
# add_to_list(variable_list constant_value)
INCLUDE(cmake/add_to_list.cmake)
#
# command_line_arg(variable default type description)
INCLUDE(cmake/command_line_arg.cmake)
#
# prefix_info(package description)
INCLUDE(cmake/prefix_info.cmake)
#
# compile_source_test(source variable)
INCLUDE(cmake/compile_source_test.cmake)
#
# assert(variable)
INCLUDE(cmake/assert.cmake)
#
# print_variable(variable)
INCLUDE(cmake/print_variable.cmake)
#
# set_compile_flags( program_name debug_which source_list)
INCLUDE(cmake/set_compile_flags.cmake)
#
# pkgconfig_info(name, system)
INCLUDE(cmake/pkgconfig_info.cmake)
#
# eigen_info()
INCLUDE(cmake/eigen_info.cmake)
#
# add_check_executable(parent_target short_name)
INCLUDE(cmake/add_check_executable.cmake)
# =============================================================================
# command line arguments
# =============================================================================
# Arguments that are no longer used
#
IF( debug_which )
   MESSAGE(FATAL_ERROR
      "Using debug_which, use cppad_debug_which or CMAKE_BUILD_TYPE instead"
   )
ENDIF( debug_which )
#
IF( cppad_sparse_list )
   MESSAGE(FATAL_ERROR
      "cppad_sparse_list has been removed from cmake command"
   )
ENDIF( cppad_sparse_list )
#
IF( cppad_deprecated )
   MESSAGE(FATAL_ERROR "cppad_deprecated has been removed from cmake command" )
ENDIF( cppad_deprecated )
#
IF( cmake_install_prefix )
   MESSAGE(FATAL_ERROR
      "cmake_install_prefix has been changed to cppad_prefix"
   )
ENDIF( cmake_install_prefix )
#
IF( cmake_install_postfix )
   MESSAGE(FATAL_ERROR
      "cmake_install_postfix has been changed to cppad_postfix"
   )
ENDIF( cmake_install_postfix )
#
FOREACH(pkg adolc eigen ipopt cppadcg)
   IF( ${pkg}_prefix )
      MESSAGE(FATAL_ERROR
         "-D ${pkg}_prefix=value has been changed to -D include_${pkg}=true"
      )
   ENDIF( ${pkg}_prefix )
ENDFOREACH(pkg adolc eigen ipopt cppadcg)
#
IF( cmake_needs_dot_slash )
   MESSAGE(FATAL_ERROR
      "cmake_needs_dot_slash was removed; see release notes for 2023-06-01"
   )
ENDIF( cmake_needs_dot_slash )
#
IF( include_eigen )
   MESSAGE(FATAL_ERROR
      "include_eigen was removed; see release notes for 2024-10-02"
   )
ENDIF( )
# -----------------------------------------------------------------------------
# Current Arguments
#
# cmake_install_datadir
command_line_arg(cmake_install_datadir share STRING
   "directory, below prefix, where cmake installs cppad data files"
)
#
# cmake_install_docdir
command_line_arg(cmake_install_docdir NOTFOUND STRING
   "directory, below prefix, where cmake installs cppad documentation files"
)
#
# cmake_install_includedirs
command_line_arg(cmake_install_includedirs include STRING
   "directories, below prefix, where cmake installs include files"
)
#
# cmake_install_libdirs
command_line_arg(cmake_install_libdirs lib STRING
   "directories, below prefix, where cmake installs library files"
)
#
# cmake_defined_ok
command_line_arg(cmake_defined_ok TRUE BOOL
   "If false, check that some symbols only get defined once"
   "If true, you can use CMakeCache.txt to store previous settings"
)
#
# cppad_prefix
command_line_arg(cppad_prefix "${CMAKE_INSTALL_PREFIX}" PATH
   "cppad install prefix"
)
#
# cppad_postfix
command_line_arg(cppad_postfix NOTFOUND STRING
   "cppad install postfix"
)
#
# cppad_cxx_flags
command_line_arg(cppad_cxx_flags "" STRING
   "compile flags used with cppad (besides debug, release, and profile flags)"
)
#
# cppad_profile_flag
command_line_arg(cppad_profile_flag NOTFOUND STRING
   "compile flag used to compile and link a profile version of a program"
)
#
# cppad_testvector
command_line_arg(cppad_testvector cppad STRING
   "Namespace of vector used for testing, one of: boost, cppad, eigen, std"
)
assert_value_in_set(cppad_testvector boost cppad eigen std)
#
# cppad_max_num_threads
command_line_arg(cppad_max_num_threads 48 STRING
   "maximum number of threads that CppAD can use use"
)
IF( "${cppad_max_num_threads}" LESS "4" )
   MESSAGE(FATAL_ERROR
      "cppad_max_num_threads is not an integer greater than or equal 4"
   )
ENDIF( "${cppad_max_num_threads}" LESS "4" )
#
# cppad_tape_id_type
command_line_arg(cppad_tape_id_type "unsigned int" STRING
   "type used to identify different tapes, size must be <= sizeof(size_t)"
)
#
# cppad_tape_addr_type
command_line_arg(cppad_tape_addr_type "unsigned int" STRING
"type used to identify variables on one tape, size must be <= sizeof(size_t)"
)
#
# cppad_static_lib
command_line_arg(cppad_static_lib FALSE BOOL
   "If true (false) the cppad library will be static (shared)"
)
#
# cppad_debug_and_release
command_line_arg(cppad_debug_and_release TRUE BOOL
   "If true the cppad library and tests will be able to mix debug and release"
)
# ----------------------------------------------------------------------------
#
# Ensure c++11 support
SET(CMAKE_REQUIRED_DEFINITIONS "")
SET(CMAKE_REQUIRED_FLAGS       "${cppad_cxx_flags}")
SET(CMAKE_REQUIRED_INCLUDES    "")
SET(CMAKE_REQUIRED_LIBRARIES   "")
SET(source "
int main(void)
{  static_assert( __cplusplus >= 201103 , \"c++11 is supported\" );
   return 0;
}"
)
compile_source_test(${cmake_defined_ok} "${source}" minimal_cplusplus )
IF( NOT minimal_cplusplus  )
   MESSAGE(STATUS "setting C++ standard to 2011")
   SET(CMAKE_CXX_STANDARD 11)
   SET(CMAKE_CXX_STANDARD_REQUIRED ON)
ENDIF( NOT minimal_cplusplus  )
#
# use_cplusplus_2014_ok
SET(source "
int main(void)
{  static_assert( __cplusplus >= 201302L , \"c++17 is supported\" );
   return 0;
}"
)
compile_source_test(${cmake_defined_ok} "${source}" use_cplusplus_2014_ok )
#
# use_cplusplus_2017_ok
SET(source "
int main(void)
{  static_assert( __cplusplus >= 201703L , \"c++17 is supported\" );
   return 0;
}"
)
compile_source_test(${cmake_defined_ok} "${source}" use_cplusplus_2017_ok )
# ----------------------------------------------------------------------------
#
# cppad_debug_and_release_01
IF (cppad_debug_and_release )
   SET(cppad_debug_and_release_01 1 )
ELSE (cppad_debug_and_release )
   SET(cppad_debug_and_release_01 0 )
ENDIF ( )
#
# cppad_debug_which
# CMAKE_BUILD_TYPE
SET(debug_even_or_odd FALSE)
IF( NOT ${cppad_debug_which} STREQUAL "" )
   assert_value_in_set(
      cppad_debug_which debug_even debug_odd debug_all debug_none
   )
ENDIF( NOT ${cppad_debug_which} STREQUAL "" )
IF( CMAKE_BUILD_TYPE )
   IF( NOT ${cppad_debug_which} STREQUAL "" )
      print_variable(CMAKE_BUILD_TYPE)
      print_variable(cppad_debug_which)
      MESSAGE(FATAL_ERROR
         "Both CMAKE_BUILD_TYPE and cppad_debug_which specified"
      )
   ENDIF( )
   STRING( TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower )
   IF(cmake_build_type_lower MATCHES debug)
      SET(cppad_debug_which "debug_all")
   ELSEIF(cmake_build_type_lower MATCHES release)
      SET(cppad_debug_which "debug_none")
   ELSEIF(cmake_build_type_lower MATCHES relwithdebInfo)
      SET(cppad_debug_which "debug_none")
   ELSEIF(cmake_build_type_lower MATCHES minsizerel)
      SET(cppad_debug_which "debug_none")
   ELSE( )
      MESSAGE(FATAL_ERROR
         "Unknonw CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}"
      )
   ENDIF( )
ELSE( ) # CMAKE_BUILD_TYPE
   IF( "${cppad_debug_which}" STREQUAL debug_all)
      SET(CMAKE_BUILD_TYPE Debug)
   ELSEIF( "${cppad_debug_which}" STREQUAL debug_none)
      SET(CMAKE_BUILD_TYPE Release)
   ELSEIF( "${cppad_debug_which}" STREQUAL debug_odd)
      SET(CMAKE_BUILD_TYPE Debug)
      SET(debug_even_or_odd TRUE)
   ELSEIF( "${cppad_debug_which}" STREQUAL debug_even)
      SET(CMAKE_BUILD_TYPE Release)
      SET(debug_even_or_odd TRUE)
   ENDIF( "${cppad_debug_which}" STREQUAL debug_all)
ENDIF( ) # CMAKE_BUILD_TYPE
IF( debug_even_or_odd )
   IF ( NOT cppad_debug_and_release )
      MESSAGE(FATAL_ERROR
"cppad_debug_and_release is false and cppad_debug_wich = ${cppad_debug_which}"
      )
   ENDIF ( NOT cppad_debug_and_release )
   IF( ${CMAKE_SYSTEM_NAME} STREQUAL "Windows" )
      MESSAGE(FATAL_ERROR
      "Cannot have cppad_debug_which equal ${cppad_debug_which} on Windows."
      )
   ENDIF( ${CMAKE_SYSTEM_NAME} STREQUAL "Windows" )
ENDIF( debug_even_or_odd )
print_variable(CMAKE_SYSTEM_NAME)
print_variable(cppad_debug_which)
print_variable(CMAKE_BUILD_TYPE)
MESSAGE(STATUS "make check: avialable")
# -----------------------------------------------------------------------------
# CMAKE_INSTALL_PREFIX
SET(CMAKE_INSTALL_PREFIX "${cppad_prefix}"
   CACHE PATH "value copied from cppad_prefix" FORCE
)
# -----------------------------------------------------------------------------
# Optional package information
# cppad_has_{package}, {package}_LINK_LIBRARIES, package INCLUDE_DIRECTORIES
#
# system_include
SET(system_include TRUE)
#
# package = eigen
eigen_info()
#
# package = adolc
pkgconfig_info(adolc ${system_include})
#
# package = ipopt
pkgconfig_info(ipopt ${system_include})
#
# package = colpack
prefix_info(colpack ${system_include} )
#
# package = sacado
prefix_info(sacado ${system_include} )
#
# package = fadbad
prefix_info(fadbad ${system_include} )
#
# check sacado
IF( ${cppad_has_sacado} )
   IF( NOT ${use_cplusplus_2017_ok} )
      MESSAGE(FATAL_ERROR "sacado_prefix is defined but c++17 not supported")
   ENDIF( )
ENDIF( )
#
# package = cppadcg
SET( include_cppadcg FALSE CACHE BOOL "include cppadcg" )
IF( include_cppadcg )
   #
   # cppad_has_cppadcg
   SET(cppad_has_cppadcg 1)
   #
   # Assume bin/get_cppadcg.sh puts include files in this directory
   SET(cppadcg_include_dir "${CMAKE_BINARY_DIR}/prefix/include" )
   print_variable(cppadcg_include_dir)
   INCLUDE_DIRECTORIES( SYSTEM ${cppadcg_include_dir})
ELSE( )

=== example/multi_thread/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-24 Bradley M. Bell
# ----------------------------------------------------------------------------

# initialize list as empty
SET(check_example_multi_thread_depends "")

# Define the operation
# CHECK_LIBRARY_EXISTS (LIBRARY FUNCTION LOCATION VARIABLE)
#  LIBRARY  - the name of the library you are looking for
#  FUNCTION - the name of the function
#  LOCATION - location where the library should be found
#  VARIABLE - variable to store the result
INCLUDE(CheckLibraryExists)

#
# sthread
ADD_SUBDIRECTORY(sthread)
#
# openmp
IF ( OpenMP_CXX_FOUND )
   # OpenMP_CXX_FLAGS - flags to add to the CXX compiler for OpenMP support
   ADD_SUBDIRECTORY(openmp)
ENDIF ( OpenMP_CXX_FOUND )
#
# pthread
SET(pthread_lib "pthread")
FIND_LIBRARY(pthread_lib_path pthread)
MESSAGE(STATUS "pthread library path = ${pthread_lib_path}")
IF ( pthread_lib_path )
   SET(CMAKE_REQUIRED_DEFINITIONS "")
   SET(CMAKE_REQUIRED_FLAGS       "")
   SET(CMAKE_REQUIRED_INCLUDES    "")
   SET(CMAKE_REQUIRED_LIBRARIES   "")
   CHECK_LIBRARY_EXISTS(
      pthread pthread_barrier_wait ${pthread_lib_path} pthread_ok
   )
   IF ( pthread_ok )
      ADD_SUBDIRECTORY(pthread)
   ENDIF ( pthread_ok )
ENDIF ( pthread_lib_path )
#
# bthread
IF ( Boost_FOUND )
   SET(CMAKE_REQUIRED_DEFINITIONS "")
   SET(CMAKE_REQUIRED_FLAGS       "")
   SET(CMAKE_REQUIRED_INCLUDES    "${Boost_INCLUDE_DIRS}")
   SET(CMAKE_REQUIRED_LIBRARIES   "${Boost_LIBRARIES}")
   SET(source "
# include <boost/thread.hpp>
int main(void)
{  boost::barrier wait(1);
   return 0;
}"
   )
   compile_source_test(${cmake_defined_ok} "${source}" boost_multi_thread_ok )
   #
   IF( boost_multi_thread_ok )
      ADD_SUBDIRECTORY(bthread)
   ENDIF( boost_multi_thread_ok )
   #
ENDIF ( Boost_FOUND )

IF( NOT( "${check_example_multi_thread_depends}" STREQUAL "" ) )
   #
   # check_example_multi_thread
   ADD_CUSTOM_TARGET(
      check_example_multi_thread
      DEPENDS ${check_example_multi_thread_depends}
   )
   MESSAGE(STATUS "make check_example_multi_thread: available")
   #
   # Change check depends in parent environment
   add_to_list(check_example_depends check_example_multi_thread)
   SET(check_example_depends "${check_example_depends}" PARENT_SCOPE)
   #
ENDIF( NOT( "${check_example_multi_thread_depends}" STREQUAL "" ) )

=== example/multi_thread/pthread/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-24 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example/multi_thread/pthread directory tests
# Inherit build type from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/.. )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list ../thread_test.cpp
   ../team_example.cpp
   ../harmonic.cpp
   ../multi_atomic_two.cpp
   ../multi_atomic_three.cpp
   ../multi_chkpoint_one.cpp
   ../multi_chkpoint_two.cpp
   ../multi_newton.cpp
   a11c_pthread.cpp
   get_started.cpp
   team_pthread.cpp
)
set_compile_flags( example_multi_thread_pthread "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( example_multi_thread_pthread EXCLUDE_FROM_ALL ${source_list} )

# Paths in which the linker will search for libraries,
# only applies to targets created after it is called
LINK_DIRECTORIES( ${pthread_lib_path} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_multi_thread_pthread
   ${cppad_lib}
   ${colpack_libs}
   ${pthread_lib}
)

# check_example_multi_thread_pthread
add_check_executable(check_example_multi_thread pthread get_started)

=== example/multi_thread/sthread/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-24 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example/multi_thread/sthread directory tests
# Inherit build type from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/.. )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list ../thread_test.cpp
   ../team_example.cpp
   ../harmonic.cpp
   ../multi_atomic_two.cpp
   ../multi_atomic_three.cpp
   ../multi_chkpoint_one.cpp
   ../multi_chkpoint_two.cpp
   ../multi_newton.cpp
   a11c_sthread.cpp
   get_started.cpp
   team_sthread.cpp
)
set_compile_flags(
   example_multi_thread_sthread "${cppad_debug_which}" "${source_list}"
)
#
ADD_EXECUTABLE( example_multi_thread_sthread EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_multi_thread_sthread
   ${cppad_lib}
   ${colpack_libs}
)

# check_example_multi_thread_sthread
add_check_executable(check_example_multi_thread sthread get_started)

=== debian/changelog ===
cppad (2025.00.00.0-1) unstable; urgency=medium

  * New upstream release
  * Change soname, rename libcppad-lib 1456.0 to 2200.0
  * Add build dependency on pkgconf

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 13 Jan 2025 09:14:10 +0000

## cppad 2025.00.00.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 ENDIF( POLICY CMP0054 )
 #
 # cppad_version is used by version.sh to get the version number.
-SET(cppad_version "20250000.0")
+SET(cppad_version "20250000.1")
 SET(cppad_url          "https://coin-or.github.io/CppAD" )
 SET(cppad_description  "Differentiation of C++ Algorithms" )
 IF( NOT DEFINED CMAKE_BUILD_TYPE)

=== debian/changelog ===
cppad (2025.00.00.1-2) unstable; urgency=medium

  * Clean bin/test_one.sh and include/cppad/configure.hpp (closes: #1044737)

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 20 Jan 2025 21:44:08 +0000

cppad (2025.00.00.1-1) unstable; urgency=medium

  * New upstream release (closes: #1093006)

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 20 Jan 2025 09:11:46 +0000

## cppad 2025.00.00.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 ENDIF( POLICY CMP0054 )
 #
 # cppad_version is used by version.sh to get the version number.
-SET(cppad_version "20250000.1")
+SET(cppad_version "20250000.2")
 SET(cppad_url          "https://coin-or.github.io/CppAD" )
 SET(cppad_description  "Differentiation of C++ Algorithms" )
 IF( NOT DEFINED CMAKE_BUILD_TYPE)

=== cppad_lib/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build and install the cppad_lib shared library
#
# split cppad_version into year;month;day;release
STRING(REGEX REPLACE
   "([0-9][0-9][0-9][0-9])([0-9][0-9])([0-9][0-9])[.]*([0-9]*)"
   "\\1;\\2;\\3;\\4"
   version_list
   ${cppad_version}
)
LIST(GET version_list 0 year)
LIST(GET version_list 1 month)
LIST(GET version_list 2 day)
LIST(GET version_list 3 release)
#
# soversion: dynamic library version number
MATH(EXPR major "${day} - 1 + 31 * ( ${month} - 1 + 12 * ( ${year} - 2019))")
IF( "${release}" STREQUAL "" )
   SET(soversion "${major}")
ELSE( "${release}" STREQUAL "" )
   SET(soversion "${major}.${release}")
ENDIF( "${release}" STREQUAL "" )
print_variable(soversion)
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   cpp_graph_op.cpp
   cppad_colpack.cpp
   csrc_writer.cpp
   json_lexer.cpp
   json_parser.cpp
   json_writer.cpp
   link_dll_lib.cpp
   temp_file.cpp
)
# END_SORT_THIS_LINE_MINUS_2
IF( cppad_has_cppadcg )
   SET(source_list ${source_list} code_gen_fun.cpp)
ENDIF( cppad_has_cppadcg )
#
set_compile_flags(cppad_lib "${cppad_debug_which}" "${source_list}" )
#
# is_windows
IF( "${is_cppad_lib_dynamic}" STREQUAL "0" )
   MESSAGE( STATUS "Windows system so building static cppad_lib")
   ADD_LIBRARY( cppad_lib STATIC ${source_list} )
ELSEIF( "${is_cppad_lib_dynamic}" STREQUAL "1" )
   MESSAGE( STATUS "Not Windows system so building shared cppad_lib")
   ADD_LIBRARY( cppad_lib SHARED ${source_list} )
   SET_TARGET_PROPERTIES( cppad_lib PROPERTIES SOVERSION ${soversion} )
   #
   FIND_LIBRARY(dl_LIBRARY dl)
   IF( dl_LIBRARY )
      TARGET_LINK_LIBRARIES(cppad_lib ${dl_LIBRARY})
   ENDIF( dl_LIBRARY )
ELSE( "${is_cppad_lib_dynamic}" == "0" )
   MESSAGE(FATAL_ERROR "CMkakeLists.txt Error: invalid is_cppad_lib_dynamic")
ENDIF( )
#
# install(TARGETS myExe mySharedLib myStaticLib
#  RUNTIME DESTINATION bin
#  LIBRARY DESTINATION lib
#  ARCHIVE DESTINATION lib/static)
INSTALL(TARGETS cppad_lib DESTINATION ${cppad_abs_libdir})

=== example/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example directory tests
# Inherit environment from ../CMakeList.txt

# initialize check_example_depends
SET(check_example_depends "")
#
# BEGIN_SORT_THIS_LINE_PLUS_1
ADD_SUBDIRECTORY(abs_normal)
ADD_SUBDIRECTORY(atomic_four)
ADD_SUBDIRECTORY(atomic_three)
ADD_SUBDIRECTORY(atomic_two)
ADD_SUBDIRECTORY(chkpoint_two)
ADD_SUBDIRECTORY(compare_change)
ADD_SUBDIRECTORY(general)
ADD_SUBDIRECTORY(get_started)
ADD_SUBDIRECTORY(graph)
ADD_SUBDIRECTORY(jit)
ADD_SUBDIRECTORY(json)
ADD_SUBDIRECTORY(multi_thread)
ADD_SUBDIRECTORY(optimize)
ADD_SUBDIRECTORY(print_for)
ADD_SUBDIRECTORY(sparse)
ADD_SUBDIRECTORY(utility)
ADD_SUBDIRECTORY(valvector)
# END_SORT_THIS_LINE_MINUS_1
#
# cppad_code_gen examples
IF( cppad_has_cppadcg )
   ADD_SUBDIRECTORY(cppad_code_gen)
ENDIF( cppad_has_cppadcg )
#
# ipopt_solve examples
IF( cppad_has_ipopt)
   ADD_SUBDIRECTORY(ipopt_solve)
ENDIF( cppad_has_ipopt)


# Add the check_example target
ADD_CUSTOM_TARGET(check_example "" DEPENDS ${check_example_depends})
MESSAGE(STATUS "make check_example: available")

# Change check depends in parent environment
add_to_list(check_depends check_example)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== pkgconfig/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-24 Bradley M. Bell
# ----------------------------------------------------------------------------
# Construct cppad.pc from cppad.pc.in; see
# http://people.freedesktop.org/~dbn/pkg-config-guide.html
# -----------------------------------------------------------------------------
# {xrst_begin pkgconfig}
# {xrst_spell
#     builddir
#     cflags
#     datadir
#     includedir
#     libdir
#     libs
# }
# {xrst_comment_ch #}
#
# CppAD pkg-config Files
# ######################
#
# Purpose
# *******
# The ``pkg-config`` program helps with the used if installed libraries
# and include files; see its
# `guide <https://people.freedesktop.org/~dbn/pkg-config-guide.html>`_
# for more information on writing an using pkg-config files.
#
# cppad.pc
# ********
#
# PKG_CONFIG_PATH
# ===============
# The ``cppad.pc`` file is installed in the following two directories:
#
# | |tab| *prefix* / *libdir* / ``pkgconfig``
# | |tab| *prefix* / *datadir* / ``pkgconfig``
#
# where *prefix* is :ref:`cmake@cppad_prefix` ,
# *libdir* is the first entry in
# :ref:`cmake@cmake_install_libdirs` ,
# and # *datadir* is
# :ref:`cmake@cmake_install_datadir` .
# In order to use ``pkg-config`` ,
# one of these directories must your ``PKG_CONFIG_PATH`` .
#
# Compile Flags
# =============
# The necessary flags for compiling code that includes CppAD can
# be obtained with the command
# ::
#
#     pkg-config --cflags cppad
#
# Link Flags
# ==========
# The flags for linking can be obtains with the command
# ::
#
#     pkg-config --libs cppad
#
# Extra Definitions
# =================
# The ``cppad.pc`` file contains the text:
#
# | |tab| ``prefix`` = *prefix*
# | |tab| ``exec_prefix`` = *exec_prefix*
# | |tab| ``includedir`` = *includedir*
# | |tab| ``libdir`` = *libdir*
#
# where *prefix* , *exec_prefix* , *includedir* , and
# *libdir* are the
# `gnu installation variables <https://www.gnu.org/prep/standards/html_node/Directory-Variables.html>`_.
#
# cppad-uninstalled.pc
# ********************
#
# PKG_CONFIG_PATH
# ===============
# The ``cppad-uninstalled.pc`` file is located in the following directory:
#
#     *builddir* / ``pkgconfig``
#
# where *builddir* is the directory where the :ref:`cmake-name` command
# is executed.
#
# Compile Flags
# =============
# The necessary flags for compiling code that includes CppAD,
# before CppAD is installed, can be obtained with the command
# ::
#
#     pkg-config --cflags cppad-uninstalled
#
# Link Flags
# ==========
# The flags for linking can be obtains with the command
# ::
#
#     pkg-config --libs cppad-uninstalled
#
# Extra Definitions
# =================
# The ``cppad-uninstalled.pc`` file has the same extra variables
# as the ``cppad.pc`` file.
#
# {xrst_end pkgconfig}
# ----------------------------------------------------------------------------
#
# The following variables are used by cppad.pc.in
# and set in the top source CMakeLists.txt:
#  cppad_prefix,
#  cppad_description,
#  cppad_version,
#  cppad_url,
#  cppad_lib
# The other variables used by cppad.pc.in are set below
# Note that cppad_SOURCE_DIR is used by cppad-uninstalled.pc
# and is set by cmake to the top soruce directory.
#
# cppad_includedir
LIST(GET cmake_install_includedirs 0 cppad_includedir)
#
# cppad_libdir
LIST(GET cmake_install_libdirs 0 cppad_libdir)
#
# add_to_set
MACRO(add_to_set variable_name element)
   IF( "${${variable_name}}" STREQUAL "" )
      SET(${variable_name} ${element} )
   ELSE( "${${variable_name}}" STREQUAL "" )
      LIST(FIND ${variable_name} ${element} index)
      IF( index EQUAL -1 )
         SET(${variable_name} "${${variable_name}} ${element}")
      ENDIF( index EQUAL -1 )
   ENDIF( "${${variable_name}}" STREQUAL "" )
ENDMACRO(add_to_set variable_name element)
# -----------------------------------------------------------------------------
# initialize
SET(cppad_libdir_list "-L${cppad_prefix}/${cppad_libdir}")
SET(cppad_lib_list    "-l${cppad_lib}")
SET(cppad_requires         "")
SET(cppad_libs_private     "")
SET(cppad_requires_private "")
#
# Colpack does not have a pkgconfig file.
SET(colpack_libdir     NOTFOUND)
IF( cppad_has_colpack )
   FOREACH(dir ${cmake_install_libdirs})
      FILE(GLOB file_list "${colpack_prefix}/${dir}/libColPack.*" )
      IF( file_list )
         SET(colpack_libdir "${colpack_prefix}/${dir}")
      ENDIF( file_list )
   ENDFOREACH(dir ${cmake_install_libdirs})
   IF( NOT colpack_libdir )
      MESSAGE(FATAL_ERROR "Cannit find libColPack.* below ${colpack_prefix}")
   ENDIF( NOT colpack_libdir )
   add_to_set(cppad_libdir_list "-L${colpack_libdir}")
   add_to_set(cppad_lib_list    "-lColPack")
ENDIF( cppad_has_colpack )
#
# Ipopt and eigen have pkgconfig files.
IF( cppad_has_eigen )
   SET(cppad_requires         "${cppad_requires} eigen3")
ENDIF( cppad_has_eigen )
IF( cppad_has_ipopt )
   SET(cppad_requires         "${cppad_requires} ipopt")
   add_to_set(cppad_lib_list  "-lcppad_ipopt" )
ENDIF( cppad_has_ipopt )
# -----------------------------------------------------------------------------
# cppad.pc
CONFIGURE_FILE(
   ${CMAKE_CURRENT_SOURCE_DIR}/cppad.pc.in
   ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
   @ONLY
)
# cppad-uninstalled.pc
CONFIGURE_FILE(
   ${CMAKE_CURRENT_SOURCE_DIR}/cppad-uninstalled.pc.in
   ${CMAKE_CURRENT_BINARY_DIR}/cppad-uninstalled.pc
   @ONLY
)
# During install copy cppad.pc to datadir
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
   DESTINATION ${cppad_abs_datadir}/pkgconfig
)
# During install also copy cppad.pc to libdir
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
   DESTINATION ${cppad_abs_libdir}/pkgconfig
)

=== test_more/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the test_more directory tests

# initialize check_depends
SET(check_test_more_depends "")

# deprecated tests
ADD_SUBDIRECTORY(deprecated)

# compare_c tests
# clange-cl.exe seems to be confused about C files and gives an erro message
# saying that C++ forbids macroizing the keywords bool, true, and false.
STRING(REGEX MATCH ".*[/\]clang-cl.exe" match "${CMAKE_C_COMPILER}" )
IF( NOT "${match}" STREQUAL "${CMAKE_C_COMPILER}" )
   ADD_SUBDIRECTORY(compare_c)
ENDIF( )
#
# debug_rel tests
IF( NOT "${CMAKE_GENERATOR}" STREQUAL "NMake Makefiles" )
   # Visual studio rejects mixing debug and release flags
   ADD_SUBDIRECTORY(debug_rel)
ENDIF( NOT "${CMAKE_GENERATOR}" STREQUAL "NMake Makefiles" )
#
# cppad_for_tmb tests
IF( OpenMP_CXX_FOUND )
   ADD_SUBDIRECTORY(cppad_for_tmb)
ENDIF( OpenMP_CXX_FOUND )

# general tests
ADD_SUBDIRECTORY(general)

# Add the check_example target
ADD_CUSTOM_TARGET(check_test_more "" DEPENDS ${check_test_more_depends})
MESSAGE(STATUS "make check_test_more: available")

# Change check depends in parent environment
add_to_list(check_depends check_test_more)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== cppad_ipopt/src/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the cppad_ipopt/src library
# Inherit build type from ../CMakeList.txt

#  add_library(<name> [STATIC | SHARED | MODULE] [EXCLUDE_FROM_ALL]
#  source1 source2 ... sourceN)
# )
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   cppad_ipopt_nlp.cpp
   hes_fg_map.cpp
   jac_g_map.cpp
   sparse_map2vec.cpp
   vec_fun_pattern.cpp
)
# END_SORT_THIS_LINE_MINUS_2

ADD_LIBRARY(cppad_ipopt ${source_list})
set_compile_flags( cppad_ipopt "${cppad_debug_which}" "${source_list}" )

# install(FILES files... DESTINATION <dir>
#  [PERMISSIONS permissions...]
#  [CONFIGURATIONS [Debug|Release|...]]
#  [COMPONENT <component>]
#  [RENAME <name>] [OPTIONAL])
INSTALL(FILES cppad_ipopt_nlp.hpp DESTINATION ${cppad_abs_includedir})

# install(TARGETS myExe mySharedLib myStaticLib
#  RUNTIME DESTINATION bin
#  LIBRARY DESTINATION lib
#  ARCHIVE DESTINATION lib/static)
INSTALL(TARGETS cppad_ipopt DESTINATION ${cppad_abs_libdir})

=== example/atomic_four/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-24 Bradley M. Bell
# ----------------------------------------------------------------------------
#
# initialize check_example_atomic_four_depends
SET(check_example_atomic_four_depends "")
#
ADD_SUBDIRECTORY(lin_ode)
ADD_SUBDIRECTORY(mat_mul)
ADD_SUBDIRECTORY(vector)
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   atomic_four.cpp
   bilinear.cpp
   dynamic.cpp
   forward.cpp
   get_started.cpp
   norm_sq.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags(example_atomic_four "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_atomic_four EXCLUDE_FROM_ALL ${source_list})
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_atomic_four
   ${cppad_lib}
   ${colpack_libs}
)
#
# check_example_atomic_four
add_check_executable(check_example atomic_four)

=== example/atomic_three/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   atomic_three.cpp
   base2ad.cpp
   dynamic.cpp
   forward.cpp
   get_started.cpp
   hes_sparsity.cpp
   jac_sparsity.cpp
   mat_mul.cpp
   norm_sq.cpp
   reciprocal.cpp
   rev_depend.cpp
   reverse.cpp
   tangent.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags(example_atomic_three "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_atomic_three EXCLUDE_FROM_ALL ${source_list})
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_atomic_three
   ${cppad_lib}
   ${colpack_libs}
)
#
# check_example_atomic_three
add_check_executable(check_example atomic_three)

=== example/cppad_code_gen/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   cppad_code_gen.cpp
   file.cpp
   function.cpp
   jac_as_fun.cpp
   jacobian.cpp
   sparse_jac_as_fun.cpp
   sparse_jacobian.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags(
   example_cppad_code_gen "${cppad_debug_which}" "${source_list}"
)
#
ADD_EXECUTABLE(example_cppad_code_gen EXCLUDE_FROM_ALL ${source_list})

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_cppad_code_gen
   ${cppad_lib}
   ${colpack_libs}
)
#
# check_example_cppad_code_gen
add_check_executable(check_example cppad_code_gen)

=== example/get_started/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example/get_started directory tests
#
SET(source_list get_started.cpp)
#
set_compile_flags( example_get_started "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_get_started EXCLUDE_FROM_ALL ${source_list})
#
TARGET_LINK_LIBRARIES(example_get_started ${cppad_lib} ${colpack_libs})
#
# check_example_get_started
add_check_executable(check_example get_started)

=== example/jit/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-23 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example/git directory tests
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   atomic.cpp
   compare_change.cpp
   compile.cpp
   dynamic.cpp
   get_started.cpp
   jit.cpp
)
# END_SORT_THIS_LINE_MINUS_2
#
set_compile_flags( example_jit "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_jit EXCLUDE_FROM_ALL ${source_list})
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_jit
   ${cppad_lib}
   ${colpack_libs}
)
#
# check_example_jit
add_check_executable(check_example jit)

=== example/json/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   add_op.cpp
   atom4_op.cpp
   atom_op.cpp
   azmul_op.cpp
   cexp_op.cpp
   comp_op.cpp
   discrete_op.cpp
   div_op.cpp
   from_json.cpp
   get_started.cpp
   json.cpp
   mul_op.cpp
   pow_op.cpp
   print_op.cpp
   sparse.cpp
   sub_op.cpp
   sum_op.cpp
   to_json.cpp
   unary_op.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags(example_json "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_json EXCLUDE_FROM_ALL ${source_list})

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_json
   ${cppad_lib}
   ${colpack_libs}
)
#
# check_example_json
add_check_executable(check_example json)

=== debian/changelog ===
cppad (2025.00.00.2-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 01 Feb 2025 21:38:11 +0000

=== debian/control ===
Source: cppad
Section: devel
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Miles Lubin <miles.lubin@gmail.com>,
           Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 13),
		dpkg-dev (>= 1.22.5),
		cmake,
		pkgconf,
		libboost-all-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://projects.coin-or.org/CppAD/
Vcs-Git: https://salsa.debian.org/science-team/cppad.git
Vcs-Browser: https://salsa.debian.org/science-team/cppad

Package: libcppad-lib2200.0
Provides: ${t64:Provides}
Replaces: libcppad-lib2200.0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Automatic Differentiation of C++ algorithms, shared library
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains runtime support, including shared libraries.

Package: libcppad-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libcppad-lib2200.0 (= ${binary:Version})
Suggests: libcppad-doc
Description: Automatic Differentiation of C++ algorithms, dev files
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains development file: C++ headers and development
 libraries.

Package: libcppad-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Automatic Differentiation of C++ algorithms, documentation
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains documentation.
 .
 (Or did, and would if the documentation source format hadn't changed
 to xrst which Debian cannot yet process, and will again at some point
 in the future. For now, see https://coin-or.github.io/CppAD/doc.)
